aboutsummaryrefslogtreecommitdiff
path: root/scripts/rellns-sh
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/rellns-sh')
-rwxr-xr-xscripts/rellns-sh66
1 files changed, 66 insertions, 0 deletions
diff --git a/scripts/rellns-sh b/scripts/rellns-sh
new file mode 100755
index 0000000000..890f4eea3a
--- /dev/null
+++ b/scripts/rellns-sh
@@ -0,0 +1,66 @@
+#! /bin/sh
+# rellns-sh - Simplified ln program to generate relative symbolic link.
+# Copyright (C) 1996, 1997 Free Software Foundation, Inc.
+# Written by Ulrich Drepper <drepper@cygnus.com>, October 1996
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+if test $# -ne 2; then
+ echo "Usage: rellns SOURCE DEST" >&2
+ exit 1
+fi
+
+# Make both paths absolute.
+if test -d $1; then
+ to=`cd $1 && /bin/pwd`
+else
+ temp=`echo $1 | sed 's%/*[^/]*$%%'`
+ if test -z "$temp"; then
+ to=`/bin/pwd`
+ else
+ to=`cd $temp && /bin/pwd`
+ fi
+ to="$to/`echo $1 | sed 's%.*/\([^/][^/]*\)$%\1%'`"
+fi
+to=`echo $to | sed 's%^/%%'`
+
+if test -d $2; then
+ from=`echo $2 | sed 's%/*$%%'`
+else
+ from=`echo $2 | sed 's%/*[^/]*$%%'`
+fi
+
+if test -z "$from"; then
+ from=`/bin/pwd | sed 's%^/%%'`
+else
+ from=`cd $from && /bin/pwd | sed 's%^/%%'`
+fi
+
+while test -n "$to" && test -n "$from"; do
+ preto=`echo $to | sed 's%^\([^/]*\)/.*%\1%'`
+ prefrom=`echo $from | sed 's%^\([^/]*\)/.*%\1%'`
+
+ test "$preto" != "$prefrom" && break
+
+ to=`echo $to | sed 's%^[^/]*/*\(.*\)$%\1%'`
+ from=`echo $from | sed 's%^[^/]*/*\(.*\)$%\1%'`
+done
+
+while test -n "$from"; do
+ rfrom="../$rfrom"
+ from=`echo $from | sed 's%^[^/]*/*%%'`
+done
+
+ln -s $rfrom$to $2